function cons(text)
	print(text)
end

function anythingbutnil(this)
	if this == nil then
		return ""
	else
		return this
	end
end

function anythingbutnil0(this)
	-- Same, but instead of an empty string return 0
	if this == nil then
		return 0
	else
		return this
	end
end

function fatalerror(msg)
	errormsg = msg
	cons("FATAL ERROR: " .. msg)
	state = -1
end

function backspace(text)
	--[[ UTF-8 library is 0.9.2+
	-- get the byte offset to the last UTF-8 character in the string.
	local byteoffset = utf8.offset(text, -1)

	if byteoffset then
		-- remove the last UTF-8 character.
		-- string.sub operates on bytes rather than UTF-8 characters, so we couldn't do string.sub(text, 1, -2).
		text = string.sub(text, 1, byteoffset - 1)
	end
	]]

	worktext = text
	while true do
		lastchar = string.sub(worktext, -1, -1) -- als dit niet werkt...
		if lastchar == "" then return "" end

		-- Are we about to kill a UTF-8 continuation byte?
		if string.sub(toBinary(lastchar), 1, 2) == "10" then
			-- We are, do this again.
			worktext = string.sub(worktext, 1, -2)
		else
			-- All clear!
			return string.sub(worktext, 1, -2)
		end
	end
end

-- numberString toBinary http://pastebin.com/LkFYQPGP
function numberString(number)
	local s = ""
	repeat
		local remainder = number % 2
		s = remainder..s
		number = (number-remainder)/2
	until number==0
	return s
end

function chartobinary(char)
	string.format("%08d",numberString(string.byte(char)))
	-- Geen wonder dat dit nil geeft!!
end

function toBinary(str)
	if #str > 0 then
		local result = ""
		for a = 1, #str do
			result = result..string.format("%08d",numberString(string.byte(string.sub(str,a,a))))
		end
		return result
	else return nil
	end
end

-- https://love2d.org/wiki/String_exploding
function explode(div, str)
	assert(type(str) == "string" and type(div) == "string", "invalid arguments for string explosion (div is " .. type(div) .. " [" .. anythingbutnil(div) .. "], str is " .. type(str) .. " [" .. anythingbutnil(str) .. "])")
	local o = {}
	while true do
		local pos1,pos2 = str:find(div)
		if not pos1 then
			o[#o+1] = str
			break
		end
		o[#o+1],str = str:sub(1,pos1-1),str:sub(pos2+1)
	end
	return o
end

function implode(div, tbl)
	return table.concat(tbl, div)
end

function startinput()
	cons("Input started (not once)")
	input = ""
	takinginput = true
end

function startinputonce()
	if not takinginput then
		cons("Input started (once)")
		input = ""
		takinginput = true
	end
end

function stopinput()
	cons("Input stopped.")
	-- Do not clear input here, because then we can't use it anymore after using stopinput(). Output will now be locked.
	takinginput = false
end

function tostate(new)
	oldstate = state
	state = anythingbutnil0(tonumber(new)) -- please
	cons("State changed: " .. oldstate .. " => " .. state)
	loadstate(state) -- just so states can be prepared easily
end

function loadstate(new)
	if new == 1 then
		roomdata = {}; roomdata[0] = {} -- temporary
		roomdata[0][0], entitydata, metadata = loademptyroom()
		success, metadata, roomdata, entitydata, _, scripts = loadlevel("testlevel.vvvvvv")
		tilespicker = false
		selectedtool = 1
		selectedtile = 1
		selectedtileset = "outside"
		selectedcolor = "red"
		lefttoolscroll = 16 -- offset
		zoomscale = 1 -- Or 1/2 or 1/4 or w/e
		dropdown = 0
		roomx = 0
		roomy = 0
	elseif new == 3 then
		scriptlines = {}
		editingline = 1
		textlinestogo = 0
		startinput()
	elseif new == 4 then
		success, metadata, contents, entities, levelmetadata, scripts = loadlevel("testlevel.vvvvvv")
	elseif new == 5 then
		userprofile = os.getenv('USERPROFILE')
		lerror, levelsfolder = getlevelsfolder()
		files = listdirs(userprofile)
	elseif new == 6 then
		--userprofi
	end
end



-------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------- Just as a filler because I need this part often ---------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------------------



function loadtileset(file)
	tilesets[file] = {}
	
	tilesets[file]["img"] = love.graphics.newImage(file)
	tilesets[file]["width"] = tilesets[file]["img"]:getWidth()
	tilesets[file]["height"] = tilesets[file]["img"]:getHeight()
	tilesets[file]["tileswidth"] = tilesets[file]["width"]/16  -- 8
	tilesets[file]["tilesheight"] = tilesets[file]["height"]/16  -- 8
	
	cons("Loading tileset: " .. file .. ", " .. tilesets[file]["width"] .. "x" .. tilesets[file]["height"] .. ", " .. tilesets[file]["tileswidth"] .. "x" .. tilesets[file]["tilesheight"])
	
	tilesets[file]["tiles"] = {}
	
	for tsy = 0, (tilesets[file]["tilesheight"]-1) do
		for tsx = 0, (tilesets[file]["tileswidth"]-1) do
			tilesets[file]["tiles"][(tsy*tilesets[file]["tileswidth"])+tsx] = love.graphics.newQuad(tsx*16, tsy*16, 16, 16, tilesets[file]["width"], tilesets[file]["height"]) -- 8 8 8 8
		end
	end
	
	
end

function mousein(x1, y1, x2, y2)
	-- Determines whether mouse is in a box with corners x1,y1 and x2,y2
	if (love.mouse.getX() >= x1) and (love.mouse.getX() <= x2) and (love.mouse.getY() >= y1) and (love.mouse.getY() <= y2) then
		return true
	else
		return false
	end
end

function mouseon(x, y, w, h)
	-- Determines whether mouse is on a box with top left corner x1,y1 and width w and height h
	if (love.mouse.getX() >= x) and (love.mouse.getX() < x+w) and (love.mouse.getY() >= y) and (love.mouse.getY() < y+h) then
		return true
	else
		return false
	end
end

function lefttoolscrollbounds()
	if (lefttoolscroll < -368) then
		lefttoolscroll = -368
	elseif (lefttoolscroll > 16) then
		lefttoolscroll = 16
	end
end

function hoverdraw(img, x, y, w, h)
	if mouseon(x, y, w, h) then
		love.graphics.draw(img, x, y)
	else
		love.graphics.setColor(255,255,255,128)
		love.graphics.draw(img, x, y)
		love.graphics.setColor(255,255,255,255)
	end
end

function hoverrectangle(r, g, b, a, x, y, w, h)
	if mouseon(x, y, w, h) then
		love.graphics.setColor(r, g, b, 255)
		love.graphics.rectangle("fill", x, y, w, h)
	else
		love.graphics.setColor(r, g, b, a)
		love.graphics.rectangle("fill", x, y, w, h)
	end
	
	love.graphics.setColor(255,255,255,255)
end

function cycle(var, themax)
	if var == themax then
		return 1
	else
		return var+1
	end
end

function t(cond, thens, elses)
	if cond then
		return thens
	else
		return elses
	end
end

function spitoutarrays()
	love.system.setClipboardText([[				blocks =
					{
					]] .. fixdig(cb[1], 4, " ") .. [[, ]] .. fixdig(cb[2], 4, " ") .. [[, ]] .. fixdig(cb[3], 4, " ") .. [[, ]] .. fixdig(cb[4], 4, " ") .. [[, ]] .. fixdig(cb[5], 4, " ") .. [[, ]] .. fixdig(cb[6], 4, " ") .. [[,
					]] .. fixdig(cb[7], 4, " ") .. [[, ]] .. fixdig(cb[8], 4, " ") .. [[, ]] .. fixdig(cb[9], 4, " ") .. [[, ]] .. fixdig(cb[10], 4, " ") .. [[, ]] .. fixdig(cb[11], 4, " ") .. [[, ]] .. fixdig(cb[12], 4, " ") .. [[,
					]] .. fixdig(cb[13], 4, " ") .. [[, ]] .. fixdig(cb[14], 4, " ") .. [[, ]] .. fixdig(cb[15], 4, " ") .. [[, ]] .. fixdig(cb[16], 4, " ") .. [[, ]] .. fixdig(cb[17], 4, " ") .. [[, ]] .. fixdig(cb[18], 4, " ") .. [[,
					]] .. fixdig(cb[19], 4, " ") .. [[, ]] .. fixdig(cb[20], 4, " ") .. [[, ]] .. fixdig(cb[21], 4, " ") .. [[, ]] .. fixdig(cb[22], 4, " ") .. [[, ]] .. fixdig(cb[23], 4, " ") .. [[, ]] .. fixdig(cb[24], 4, " ") .. [[,
					]] .. fixdig(cb[25], 4, " ") .. [[, ]] .. fixdig(cb[26], 4, " ") .. [[, ]] .. fixdig(cb[27], 4, " ") .. [[, ]] .. fixdig(cb[28], 4, " ") .. [[, ]] .. fixdig(cb[29], 4, " ") .. [[, ]] .. fixdig(cb[30], 4, " ") .. [[,
					},
				background =
					{
					]] .. fixdig(ca[1], 4, " ") .. [[, ]] .. fixdig(ca[2], 4, " ") .. [[, ]] .. fixdig(ca[3], 4, " ") .. [[, ]] .. fixdig(ca[4], 4, " ") .. [[, ]] .. fixdig(ca[5], 4, " ") .. [[, ]] .. fixdig(ca[6], 4, " ") .. [[,
					]] .. fixdig(ca[7], 4, " ") .. [[, ]] .. fixdig(ca[8], 4, " ") .. [[, ]] .. fixdig(ca[9], 4, " ") .. [[, ]] .. fixdig(ca[10], 4, " ") .. [[, ]] .. fixdig(ca[11], 4, " ") .. [[, ]] .. fixdig(ca[12], 4, " ") .. [[,
					]] .. fixdig(ca[13], 4, " ") .. [[, ]] .. fixdig(ca[14], 4, " ") .. [[, ]] .. fixdig(ca[15], 4, " ") .. [[, ]] .. fixdig(ca[16], 4, " ") .. [[, ]] .. fixdig(ca[17], 4, " ") .. [[, ]] .. fixdig(ca[18], 4, " ") .. [[,
					]] .. fixdig(ca[19], 4, " ") .. [[, ]] .. fixdig(ca[20], 4, " ") .. [[, ]] .. fixdig(ca[21], 4, " ") .. [[, ]] .. fixdig(ca[22], 4, " ") .. [[, ]] .. fixdig(ca[23], 4, " ") .. [[, ]] .. fixdig(ca[24], 4, " ") .. [[,
					]] .. fixdig(ca[25], 4, " ") .. [[, ]] .. fixdig(ca[26], 4, " ") .. [[, ]] .. fixdig(ca[27], 4, " ") .. [[, ]] .. fixdig(ca[28], 4, " ") .. [[, ]] .. fixdig(ca[29], 4, " ") .. [[, ]] .. fixdig(ca[30], 4, " ") .. [[,
					},
				spikes =
					{
					]] .. fixdig(cs[1], 4, " ") .. [[, ]] .. fixdig(cs[2], 4, " ") .. [[, ]] .. fixdig(cs[3], 4, " ") .. [[, ]] .. fixdig(cs[4], 4, " ") .. [[, ]] .. fixdig(cs[5], 4, " ") .. [[, ]] .. fixdig(cs[6], 4, " ") .. [[,
					]] .. fixdig(cs[7], 4, " ") .. [[, ]] .. fixdig(cs[8], 4, " ") .. [[, ]] .. fixdig(cs[9], 4, " ") .. [[, ]] .. fixdig(cs[10], 4, " ") .. [[, ]] .. fixdig(cs[11], 4, " ") .. [[, ]] .. fixdig(cs[12], 4, " ") .. [[,
					]] .. fixdig(cs[13], 4, " ") .. [[, ]] .. fixdig(cs[14], 4, " ") .. [[, ]] .. fixdig(cs[15], 4, " ") .. [[, ]] .. fixdig(cs[16], 4, " ") .. [[, ]] .. fixdig(cs[17], 4, " ") .. [[, ]] .. fixdig(cs[18], 4, " ") .. [[,
					]] .. fixdig(cs[19], 4, " ") .. [[, ]] .. fixdig(cs[20], 4, " ") .. [[, ]] .. fixdig(cs[21], 4, " ") .. [[, ]] .. fixdig(cs[22], 4, " ") .. [[, ]] .. fixdig(cs[23], 4, " ") .. [[, ]] .. fixdig(cs[24], 4, " ") .. [[,
					]] .. fixdig(cs[25], 4, " ") .. [[, ]] .. fixdig(cs[26], 4, " ") .. [[, ]] .. fixdig(cs[27], 4, " ") .. [[, ]] .. fixdig(cs[28], 4, " ") .. [[, ]] .. fixdig(cs[29], 4, " ") .. [[, ]] .. fixdig(cs[30], 4, " ") .. [[,
					}]])
end

function fixdig(number, dig, filler)
	if filler == nil then filler = "0" end

	if string.len(tostring(number)) > dig then
		return string.rep("9", dig)
	elseif string.len(tostring(number)) == dig then
		return tostring(number)
	else
		return string.rep(filler, dig-string.len(tostring(number))) .. tostring(number)
	end
end

function syntaxhl(text, x, y, thisistext, addcursor)
	if thisistext then
		setColorArr(syntaxcolors.textbox)
		love.graphics.print(text, x, y)
		offsetchars = string.len(text) + 1
		
		if addcursor then
			setColorArr(syntaxcolors.cursor)
			love.graphics.print(__, x+((offsetchars-1)*8), y)
		end
		
		return nil
	else
		offsetchars = 0
		
		--if text ~= "" then
		-- Replace characters by one with which we will split.
		text2 = string.gsub(string.gsub(string.gsub(text, "%(", ","), "%)", ","), " ", ",")
		
		partss = explode(",", text2)

		for k,v in pairs(partss) do
			if offsetchars == 0 then -- First word on the line, so it's a command.
				-- But is it recognized?
				if (addcursor and #partss == 1) or knowncommands[v] or knowninternalcommands[v] then
					setColorArr(syntaxcolors.command)
				else
					setColorArr(syntaxcolors.errortext)
				end
			elseif tostring(tonumber(v)) == tostring(v) then -- It's a number!
				setColorArr(syntaxcolors.number)
			else
				setColorArr(syntaxcolors.generic)
			end
			love.graphics.print(v, x+(offsetchars*8), y)

			setColorArr(syntaxcolors.separator)
			love.graphics.print(string.sub(text, 1+offsetchars+string.len(v), 1+offsetchars+string.len(v)), x+(offsetchars*8)+(string.len(v)*8), y)
			
			offsetchars = offsetchars + (string.len(v)+1)
		end
		
		if addcursor then
			setColorArr(syntaxcolors.cursor)
			love.graphics.print(__, x+((offsetchars-1)*8), y)
		end
		
		if partss[1] == "say" or partss[1] == "reply" then
			if partss[2] == nil then
				return 1
			else
				return tonumber(partss[2])
			end
		elseif partss[1] == "text" then
			if partss[5] == nil then
				return 1
			else
				return tonumber(partss[5])
			end
		end
	end
	--end
end

function setColorArr(yourarray)
	love.graphics.setColor(yourarray[1], yourarray[2], yourarray[3])
end

function langkeys(strin, thesekeys)
	-- Fills in $1 $2 etc in the strings.
	for lk,lv in pairs(thesekeys) do
		strin = strin:gsub("$" .. lk, lv)
	end
	
	return strin
end

function userdatathing(thing)
	for thingy in thing:lines() do
		return thingy
	end
end