-- Ok the array (roomdata) with tiles is just continuous for a single room (so it has 1200 items) FOR each array item, roomdata[y][x] contains all the tiles
-- The array entitydata is an array containing entities as subarrays
-- And then there's a roommeta array that contains all the metadata of a room (like roomname and such)

-- This is per room so multiple arrays can be set if zoomed out.

--[[ Also, somewhere, there should be an array with tilesets and all their colors but what tiles they actually use in what tileset
Something like:

tilesets =
	{
	'ship' =
		{
		'tilesetid' = 46,
		'tileimg' = 'tiles2',
		'colors' =
			{
			'red' =
				{
				'colorid' = 15,
				'blocks' =
					{
					1, 2, 3, 11, 12, 13, 21, 22, 23
					},
				'background' =
					{
					31, 32, 33, 41, 42, 43, 51, 52, 53
					}
				}
			}
		}
	}
]]


function loademptyroom()
	-- Generate an entirely empty room with no entities nor metadata.
	cons("Generating empty room")
	
	myroomdata = {}
	
	for k = 1, 1200 do
		myroomdata[k] = 0 -- Just to test.
	end
	
	myentitydata = {}
	
	mymetadata = {}
	
	mymetadata.roomname = "Untitled room"
	mymetadata.tileset = 1
	
	return myroomdata, myentitydata, mymetadata
end

function loadrohiom(x, y)
	-- Loads blocks of a room from level data and prepares it for display. Also loads entities and metadata.
	
	return myroomdata, myentitydata, mymetadata
end

function displayroom(offsetx, offsety, theroomdata, themetadata)
	-- This assumes the room is already loaded in roomdata. It just displays a room, without the entities. Also include scale for zooming out.
	for aty = 0, 29 do
		for atx = 0, 39 do
			-- Display roomdata[(aty*40)+(atx+1)]
			--cons("Will display: (aty*40)+(atx+1) in other words " .. (aty*40)+(atx+1) .. " (at " .. atx .. " " .. aty .. ")")
			love.graphics.draw(tilesets[tilesetnames[themetadata.tileset]]["img"], tilesets[tilesetnames[themetadata.tileset]]["tiles"][tonumber(theroomdata[(aty*40)+(atx+1)])], offsetx+(16*atx*zoomscale), offsety+(16*aty*zoomscale), 0, zoomscale)
		end
	end
end

function displaytilespicker(offsetx, offsety, tilesetname)
	love.graphics.draw(tilesets[tilesetname]["img"], offsetx, offsety)
end

function displaysmalltilespicker(offsetx, offsety, chosentileset, chosencolor)
	for ly = 0, 4 do
		for lx = 0, 5 do
			-- The number is (6ly)+lx+1. The below line is a monster.
			if selectedtool == 1 then -- wall
				love.graphics.draw(tilesets[tilesetnames[tilesetblocks[chosentileset].tileimg]]["img"], tilesets[tilesetnames[tilesetblocks[chosentileset].tileimg]]["tiles"][tilesetblocks[chosentileset].colors[chosencolor].blocks[(6*ly)+lx+1]], offsetx+(16*lx), offsety+(16*ly))
			elseif selectedtool == 2 then -- background
				love.graphics.draw(tilesets[tilesetnames[tilesetblocks[chosentileset].tileimg]]["img"], tilesets[tilesetnames[tilesetblocks[chosentileset].tileimg]]["tiles"][tilesetblocks[chosentileset].colors[chosencolor].background[(6*ly)+lx+1]], offsetx+(16*lx), offsety+(16*ly))
			elseif selectedtool == 3 then -- spikes
				love.graphics.draw(tilesets[tilesetnames[tilesetblocks[chosentileset].tileimg]]["img"], tilesets[tilesetnames[tilesetblocks[chosentileset].tileimg]]["tiles"][tilesetblocks[chosentileset].colors[chosencolor].spikes[(6*ly)+lx+1]], offsetx+(16*lx), offsety+(16*ly))
			end

			-- Are we hovering on this tile?
			if mouseon(offsetx+(16*lx), offsety+(16*ly), 16, 16) then
				love.graphics.draw(cursorimg[0], offsetx+(16*lx), offsety+(16*ly))
				
				-- Heck, maybe we're even clicking this.
				if love.mouse.isDown("l") then
					if selectedtool == 1 then -- wall
						youhavechosen = tilesetblocks[chosentileset].colors[chosencolor].blocks[(6*ly)+lx+1]
					elseif selectedtool == 2 then -- background
						youhavechosen = tilesetblocks[chosentileset].colors[chosencolor].background[(6*ly)+lx+1]
					elseif selectedtool == 3 then -- spikes
						youhavechosen = tilesetblocks[chosentileset].colors[chosencolor].spikes[(6*ly)+lx+1]
					end
					
					cons("Tile selected: " .. youhavechosen)
				
					selectedtile = youhavechosen
				end
			end
		end
	end
end



function displayentities()
	-- This assumes the entities for this room are already loaded in entitydata. It just displays all entities.
end