-- First some things that could as well have gone in const.lua but are here for easy .
metadataitems =
	{
	"Creator", -- name
	"Title",
	"Created", -- 2?
	"Modified", -- empty?
	"Modifiers", -- 2?
	"Desc1", "Desc2", "Desc3",
	"website"
	}

function loadlevel(path)
	-- Returns (bool)success, (array)metadata, (array)contents, (array)entities, (array)levelmetadata, (array)scripts
	-- Map size and music is gonna move in with the metadata here.
	-- Contents is basically the raw array exploded
	-- Entities bestaat uit arrays (entity contents are array item data)
	-- Of course levelmetadata is all 400 rooms and also consists of arrays (roomname is array item roomname)
	-- Scripts are pre-exploded and scripts[scriptname] = (array)contents
	
	-- Ok we have the file at path...
	if not love.filesystem.isFile(path) then
		-- Doesn't exist.
		cons("File " .. path .. " doesn't exist!")
		return false
	end
	
	-- Now load the level contents!
	contents = love.filesystem.read(path)
	
	x = {}
	
	-- First do the metadata. Normally when I think of regex: "\]\[\[\\'))-)()_)()|\\'\\|"++(*9_(9[a-z]??'\\|_))_"
	x.metadata = contents:match("<MetaData>(.*)</MetaData>")
	thismetadata = {}
	for _,v in pairs(metadataitems) do
		thismetadata[v] = x.metadata:match("<" .. v .. ">(.*)</" .. v .. ">")
	end
	
	-- But we'll have room size and music also move in with the metadata. Maybe change the regex so it'll match numbers only, for now that's not necessary.
	thismetadata.mapwidth = tonumber(contents:match("<mapwidth>(.*)</mapwidth>"))
	thismetadata.mapheight = tonumber(contents:match("<mapheight>(.*)</mapheight>"))
	thismetadata.levmusic = tonumber(contents:match("<levmusic>(.*)</levmusic>"))
	
	-- TEMPORARY
	thismetadata.tileset = 1
	
	-- Now, the contents!
	x.alltiles = explode(",", contents:match("<contents>(.*)</contents>"))
	
	-- Ok we need to correctly set all rooms... Rooms have 1200 tiles
	theserooms = {}
	for yk = 0, thismetadata.mapheight-1 do
		theserooms[yk] = {}
		for xk = 0, thismetadata.mapwidth-1 do
			theserooms[yk][xk] = {}
			for yt = 0, 29 do
				for xt = 0, 39 do
					theserooms[yk][xk][(40*yt) + xt + 1] = tonumber(anythingbutnil0(x.alltiles[(yk*1200*thismetadata.mapwidth) + (xk*40) + (yt*thismetadata.mapwidth*40) + xt + 1]))
					--cons("Tile loaded: " .. (yk*1200*thismetadata.mapwidth) + (xk*40) + (yt*thismetadata.mapwidth*40) + xt + 1 .. " (" .. xk .. " " .. yk .. " " .. xt .. " " .. yt .. "), " .. yk .. "*1200*" .. thismetadata.mapwidth .. " + " .. xk .. "*40 + " .. yt .. "*" .. thismetadata.mapwidth .. "*40 + " .. xt .. " + 1")
				end
			end
		end
	end
	
	-- Entities
	
	-- Level meta data
	
	-- Scripts
	
	-- No longer x.alltiles
	return true, thismetadata, theserooms, nil, nil, nil
end

function savelevel(path)
	
end